<%@ page import="java.util.*, com.ibm.ws.console.wbi.common.ComplexForm, com.ibm.ws.console.wbi.common.GenericCollectionForm, org.apache.struts.util.MessageResources, javax.servlet.http.HttpSession"%>


<%@page import="com.ibm.ws.console.wbi.ndtopology.config.TopologyLayoutDetailForm"%>
<%@page import="com.ibm.wbiserver.nd.topology.config.TopologyConfiguration"%>
<%@page import="com.ibm.wbiserver.nd.topology.config.aspect.TopologyConfigurationAspect"%>
<%@page import="com.ibm.wbiserver.nd.topology.config.TopologyConfigurationConstants"%>
<%@page import="com.ibm.wbiserver.nd.topology.config.component.ComponentConfiguration"%>
<%@page import="com.ibm.wbiserver.nd.topology.config.component.ConfigurationState"%>
<%@page import="com.ibm.websphere.models.config.wbi.nd.topology.instance.WBIDeploymentTarget"%>
<%@page import="java.io.OutputStream"%>
<%@page import="java.io.IOException"%>
<%@page import="java.util.logging.Logger"%>
<%@page import="java.util.logging.Level"%>

<script language="JavaScript">

<%!
final static private Logger log = Logger.getLogger(ComponentConfiguration.class.getName());
%>

var layoutCompleted = false;

var TabUnitOptions = new Array()
<%!
    String getJSOptionArrays(String complexKey, String label, int idxTab, MessageResources messages, Locale locale, HttpSession session)
    {
	     String varUO = "UnitOptions"+idxTab;
		 String result=varUO+" = new Array()\n";
		 ComplexForm compForm = (ComplexForm)session.getAttribute(complexKey);
		 Set prefixSet = compForm.getPrefixSet();
		 result+=varUO+"[0]=\""+messages.getMessage(locale, "NDT.AddSelection.Desc.FirstLine")+"\"\n";
		 for(int i=0; i<prefixSet.size(); i++){
			 int idx = i+1;
			 result+=varUO+"["+idx+"]=\""+messages.getMessage(locale, label, new String[]{Integer.toString(idx)})+"\"\n";
		 }
		 result+="TabUnitOptions["+idxTab+"]="+varUO+"\n\n";
		 return result;
    }

	String setUpRadioGroupMapping(String complexKey, String columnName, HttpSession session)
	{
		 int counter = 0;
		 ComplexForm compForm = (ComplexForm)session.getAttribute(complexKey);
		 Set prefixSet = compForm.getPrefixSet();
		 String result= "";
		 String prefixStr = "";
		 GenericCollectionForm componentCollectionForm = null;
		 Iterator componentCollectionsIterator = prefixSet.iterator();
		 
		 // The radioGroupMapArrayName is a pre-defined constant used to compose 
		 // the column specific radio group name for forms that considered the radio groups in multiple collection as ONE radio group.
		 // An example usage is the brManager radio button groups in topology layout.
		 String radioGroupMapArrayName = "RadioGroupMap";
		 String prefixSeparator = "_";
		 String suffixSeparator = "-";

			
		 while (componentCollectionsIterator.hasNext()) {
			prefixStr = componentCollectionsIterator.next().toString();
			// Get the collection of DeployTargetComponentDetailForm.
			componentCollectionForm = (GenericCollectionForm)compForm.getSubForm(prefixStr);
			int componentCollectionSize = (componentCollectionForm.getContents()).size();
			// Iterate through the list of DeployTargetComponentDetailForm
			for (int j=0; j < componentCollectionSize; j++)
			{
				result+= columnName + radioGroupMapArrayName + "[" + counter++ + "]=\"" +prefixStr + prefixSeparator + columnName + suffixSeparator + (j+1) + "\";\n";
			}
		 }
		 return result;
	}
 %>
 

<%
MessageResources messages = (org.apache.struts.util.MessageResources)pageContext.getServletContext().getAttribute(org.apache.struts.action.Action.MESSAGES_KEY);
out.write(getJSOptionArrays("NDT_DeployTargetMessaging", "NDT.AddSelection.Desc.Messaging", 0, messages, request.getLocale(), session));
out.write(getJSOptionArrays("NDT_DeployTargetCEI", "NDT.AddSelection.Desc.CEI", 1, messages, request.getLocale(), session));
out.write(getJSOptionArrays("NDT_DeployTargetComponent", "NDT.AddSelection.Desc.Component", 2, messages, request.getLocale(), session));
%>
var brManagerRadioGroupMap = new Array();

<%
out.write(setUpRadioGroupMapping("NDT_DeployTargetComponent", "brManager", session));
%>

// configuredComponents[unit id][component id][deployment target] = deployment target
var configuredComponents = new Array();

function addConfiguredComponent(unitId, componentId, dt) {
    var cids = configuredComponents[unitId];
    if (!cids) {
        cids = new Object();
        configuredComponents[unitId] = cids;
    }
    var dts = cids[componentId];
    if (!dts) {
        dts = new Object();
        cids[componentId] = dts;
    }   
    dts[dt] = dt;
}

function isComponentConfigured(unitId, componentId, dt) {
    var cids = configuredComponents[unitId];
    if (cids) {
        var dts = cids[componentId];
        return (dts && dts[dt]) ? true : false;
    }

    return false;
}

<%!
void addConfiguredComponents(TopologyConfigurationAspect aspect, String componentType, String componentId, JspWriter out) throws IOException {
    TopologyConfiguration tc = (aspect == null ? null : aspect.getTopologyConfiguration());
    if (tc != null) {
        List<ComponentConfiguration> components = tc.getComponents(componentType);
        Iterator<ComponentConfiguration> it = components.iterator();
        while (it.hasNext()) {
            ComponentConfiguration component = it.next();
            
            if (component != null) {
                if (log.isLoggable(Level.FINEST)) {
                    int unit = aspect.getUnit(component);
                    WBIDeploymentTarget dt = tc.getDeploymentTarget(component);
                    
                    log.log(Level.FINEST, "addConfiguredComponents {component, component type, unit, deployment target, set, config state}: " 
                           + component.getName() + ", " + componentType + ", " + unit + ", " + (dt == null ? "none" : tc.getScope(dt)) + ", "
                           + component.isSet() + ", " + component.getConfiguration());
                }
                
                // If the component has been configured, add it to the list
                if (component.isSet() && component.getConfiguration() == ConfigurationState.configured) {
                    int unit = aspect.getUnit(component);
                    WBIDeploymentTarget dt = tc.getDeploymentTarget(component);
                    if (dt != null) {
                        String dtId = tc.getShortScope(dt);
                        out.write("addConfiguredComponent(");
                        out.write(Integer.toString(unit));
                        out.write(", '");
                        out.write(componentId);
                        out.write("', '");
                        out.write(dtId);
                        out.write("');\n");
                    }
                }
            }
        }
    }
}
%>

<%
/*
List of components that have already been configured.
The radio/checkboxes will be checked and disabled for components that have already been configured.

Radio/checkbox identifier: <topCollectionPrefixes><unit number>_<component id>-<row number in table>
Radio group identifer:     <topCollectionPrefixes><unit number>_<component id>
where:
    topCollectionPrefixes: Identfier for topology aspect
    component id: One of: local (ME), server (CEI), sca, bpcContainer, bpcExplorer, bpcEventCollector, brManager

Component configuration status:
    configuredComponents[unit id][component id] = [deployment target]
    dt in list: the component has already been configured. The control is disabled and checked
    dt not in list: the component has not been configured. The control will be enabled if selectable (component configuration conditions are met).
        The control may get checked if a saved deployment environment configuration is read or the user has aelected it. By default, the
        control is unchecked.
    deployment target:
        <server name>:<node name> or <cluster name>
        Mapping example:
            <input type="hidden" name="com.ibm.ws.console.wbi.ndtopology.config.DeployTargetMessagingDetailForm_Collection_0_local-1" value="false" title="server1:TPSAB" >
*/

TopologyLayoutDetailForm form = (TopologyLayoutDetailForm)session.getAttribute(TopologyLayoutDetailForm.class.getName());

addConfiguredComponents(form.getMessagingAspect(), TopologyConfigurationConstants.WBI_SIB, "local", out);

addConfiguredComponents(form.getCEIAspect(), TopologyConfigurationConstants.WBI_CEI, "server", out);

addConfiguredComponents(form.getAppSupportAspect(), TopologyConfigurationConstants.WBI_SCA, "sca", out);
addConfiguredComponents(form.getAppSupportAspect(), TopologyConfigurationConstants.WBI_BPC, "bpcContainer", out);
addConfiguredComponents(form.getAppSupportAspect(), TopologyConfigurationConstants.WBI_BPCExplorer, "bpcExplorer", out);
addConfiguredComponents(form.getAppSupportAspect(), TopologyConfigurationConstants.WBI_BPCEventCollector, "bpcEventCollector", out);
addConfiguredComponents(form.getAppSupportAspect(), TopologyConfigurationConstants.WBI_BRM, "brManager", out);
%>

<%
/*
doEnableDisableRadioButtons() is the entry point for the topology layout radio button enable/disable routine.
The rules for the radio buttons enable/disable is specified in defect 474047 with modifications specified by Thomas

Here are the rules:
- For each unit in CEI (or application support)
     For each deployment target
        if deployment target is in a Message unit and any server configured in that message unit
        is checked and enabled => CEI deployment target enabled. (sca for that dt enabled).

- For each unit in app support

    get isBPCContainerSelected selected and enabled for each unit.
    
    for each deployment target
       if sca is checked => bpc container enabled.
       
    if isBPCContainerSelected -> bpcExplorer enabled
    if isBPCContainerSelected and CEI for this dt are selected ==> BPC Event Collector enabled.
    if BPC Event Collector enabled -> bpc observer enabled.


- BR is always enabled.
    
*/
%>

var prefixSeparator = "_";
var suffixSeparator = "-";
var messagingTabIndex = 0;
var CEITabIndex = 1;
var AppSupportTabIndex = 2;
// The radio group column control that represents the unit in each tab.
var topRadioGroupColumns = ["local", "server", "bpcEventCollector"];
// The column control to be checked in each tab.
var topCheckColumns = ["local", "server", "sca"];

// For sca, it is a checkbox and the checkbox has a cb_ prefix.
var topActionControlPrefix = ["","","cb_"];

// The collection prefix for each topology layout tab.
var topCollectionPrefixes = ["com.ibm.ws.console.wbi.ndtopology.config.DeployTargetMessagingDetailForm_Collection_",
				     "com.ibm.ws.console.wbi.ndtopology.config.DeployTargetCEIDetailForm_Collection_",
				     "com.ibm.ws.console.wbi.ndtopology.config.DeployTargetComponentDetailForm_Collection_"];

var bpcContainer = "bpcContainer";
var bpcEventCollector = "bpcEventCollector";
var bpcExplorer = "bpcExplorer";
//var bpcObserver = "bpcObserver";

function DisableAndResetElement(prefix, id){
	DisableElement(prefix,id);
	document.getElementById(prefix+id).checked =  false;
}

function selectConfigControl(prefix, id) {
    document.getElementById(prefix + id).checked = true;   
}

function deselectConfigControl(prefix, id) {
    document.getElementById(prefix + id).checked = false;   
}

function resetHiddenControlValue(hiddenActionControlId)
{
	if (document.getElementsByName(hiddenActionControlId) != null)
	{
		var hiddenFieldVarCount = document.getElementsByName(hiddenActionControlId).length;
		for (var j=0; j <hiddenFieldVarCount; j++)
		{
			var hiddenActionControl = document.getElementsByName(hiddenActionControlId)[j];
			if (hiddenActionControl.type == "hidden")
			{
				hiddenActionControl.value = false;
			}
		}
	}
}

function isControlCheckedAndEnabled(hiddenControlValue, realControlId)
{
	// Make sure the real control is enabled. Use getElementById with the realControlId to get the actual control.
	return ( (hiddenControlValue == "true") && 
			(!(document.getElementById(realControlId).disabled)) ) ;
}

function isControlChecked(hiddenControlValue, realControlId)
{
    // The control needs to be checked only. This means that the corresponding component has been configured.
    // The control does not need to be enabled.
    return (hiddenControlValue == "true");
}


// Return true if any messaging dt is enabled in a unit that contains the deployment target.
function isMessagingDTEnabled(deploymentTarget)
{
	return isDTCheckedAndEnabled(deploymentTarget, messagingTabIndex, false);
}

function isDTCheckedAndEnabled(deploymentTarget, tabUnit, forSameDT)
{
    var isDTCheckedAndEnabled = false;
    var unitOptions = TabUnitOptions[tabUnit];
    // Number of units is one last than the drop down list because of the first default value.
    var numOfUnits = unitOptions.length - 1;

    for(var i=0; i<numOfUnits; i++)
    {
		var isOneControlCheckedAndEnabled = false;
		var hasDt = false;

		var radioGroup = topCollectionPrefixes[tabUnit] + i + prefixSeparator + topRadioGroupColumns[tabUnit];
		var hiddenControlPrefix = topCollectionPrefixes[tabUnit] + i + prefixSeparator + topCheckColumns[tabUnit];
		// get the radio group control
		var radioGroupCtrl = document.getElementsByName(radioGroup);
		for (var j=0; j < radioGroupCtrl.length; j++)
		{
			// get the hidden variable value
			var hiddenControlId = hiddenControlPrefix + suffixSeparator + (j+1);
			var hiddenControlCount = document.getElementsByName(hiddenControlId).length;
			for (var k=0; k <hiddenControlCount ;k++)
			{
				var hiddenControl = document.getElementsByName(hiddenControlId)[k];
				if (hiddenControl.type == "hidden")
				{
					var currentControlCheckedAndEnabled = false;
					var currentControlIsDT = false;
					
					if (isControlChecked(hiddenControl.value, hiddenControlId))
					{
						isOneControlCheckedAndEnabled = true;
						currentControlCheckedAndEnabled = true;
					}

					var title = hiddenControl.title;
					if (title == deploymentTarget)
					{
						hasDt = true;
						currentControlIsDT = true;
					}
					
					// If forSameDT is true, the title should equals the deploymentTarget and the control should be checked and enabled.
					if (forSameDT)
					{
						isDTCheckedAndEnabled = (currentControlIsDT && currentControlCheckedAndEnabled);
					}
					else
					{
						isDTCheckedAndEnabled = (hasDt && isOneControlCheckedAndEnabled);
					}
					
					if (isDTCheckedAndEnabled)
						break;
				}
			} // for (var k=0...
			if (isDTCheckedAndEnabled)
				break;
		} // for (var j=0...
		if (isDTCheckedAndEnabled)
			break;
	} //for(var i=0; 
	return isDTCheckedAndEnabled;
}

function isBPCContainerSelected(unit)
{
	return isOneRadioButtonSelected(unit, bpcContainer);
}
function isBPCEventCollectorSelected(unit)
{
	return isOneRadioButtonSelected(unit, bpcEventCollector);
}

// Return true if one radio button in the radio button group is selected.
function isOneRadioButtonSelected(unit, radioButtonColumn)
{
    var isOneRadioButtonSelected = false;
    // Using the app support tab
    var tabUnit = AppSupportTabIndex;
    var unitOptions = TabUnitOptions[tabUnit];
    // Number of units is one last than the drop down list because of the first default value.
    var numOfUnits = unitOptions.length - 1;

	var radioGroup = topCollectionPrefixes[tabUnit] + unit + prefixSeparator + radioButtonColumn;
	var radioGroupCtrl = document.getElementsByName(radioGroup);
	for (var j=0; j < radioGroupCtrl.length; j++)
	{
		var hiddenControlId = radioGroup + suffixSeparator + (j+1);
		var hiddenControlCount = document.getElementsByName(hiddenControlId).length;
		for (var k=0; k <hiddenControlCount; k++)
		{
			var control = document.getElementsByName(hiddenControlId)[k];
			if (control.type == "hidden")
			{
			    if (isControlChecked(control.value, hiddenControlId))
				{
					isOneRadioButtonSelected = true;
					break;
				}
			}
		}// for (var k=0; 
		if (isOneRadioButtonSelected)
			break;
	} //for (var j=0; 

	return isOneRadioButtonSelected;
}

function enableDisableRadioButtonGroup(topCollectionPrefix, unit, radioButtonColumn, toEnable)
{
    var tabUnit = AppSupportTabIndex;
	var radioGroup = topCollectionPrefix + unit + prefixSeparator + radioButtonColumn;
	var radioGroupCtrl = document.getElementsByName(radioGroup);
	var radioControlIdPrefix = radioGroup + suffixSeparator;
    var hiddenControlIdPrefix = topCollectionPrefix + unit + prefixSeparator + radioButtonColumn + suffixSeparator;
    
	for (var j=0; j < radioGroupCtrl.length; j++)
	{
        // Getting the current configuration. If configured, the ctonrol is disabled and selected
        var hiddenControlId = hiddenControlIdPrefix + (j+1);
        var hiddenControl = getHiddenControl(hiddenControlId);
        var deploymentTarget = hiddenControl.title;
        var currentControlConfigured = isComponentConfigured(unit, radioButtonColumn, deploymentTarget);

        // Do not change the selection if the component has already been configured
        if (!currentControlConfigured) {
    		if (toEnable) {
    			EnableElement(radioControlIdPrefix, (j+1));
    		} else
    		{
    			DisableAndResetElement(radioControlIdPrefix, (j+1));
    			resetHiddenControlValue(radioControlIdPrefix + (j+1));
    		}
        }
	}
}

function getHiddenControl(hiddenControlId) {
    var controls = document.getElementsByName(hiddenControlId);
    for (var i = 0; i < controls.length; i++) {
        var control = controls[i];
        if (control.type == 'hidden') {
            return control;
        }    
    }
    return null;
}

function isComponentConfiguredInUnit(componentType, unitId, tabId)
{
    var topCollectionPrefix = topCollectionPrefixes[tabId];
    var radioGroupColumn = topRadioGroupColumns[tabId];
    var topCheckColumn = topCheckColumns[tabId];
    
    var radioGroupName = topCollectionPrefix + unitId + prefixSeparator + radioGroupColumn;
    var radioGroup = document.getElementsByName(radioGroupName);

    var hiddenControlIdPrefix = topCollectionPrefix + unitId + prefixSeparator + topCheckColumn + suffixSeparator;

    var oneDTAlreadyConfigured = false;
    // Check for DT already configured in the given unit
    for (var row=0; row < radioGroup.length; row++ ) {    
        var rowId = row + 1;
        
        var hiddenControlId = hiddenControlIdPrefix + rowId;
        var hiddenControl = getHiddenControl(hiddenControlId);
        var deploymentTarget = hiddenControl.title;
        // Set the radio button control to disabled and selected if it has already been configured.
        var controlConfigured = isComponentConfigured(unitId, componentType, deploymentTarget);
        if (controlConfigured)
        {
            oneDTAlreadyConfigured = true;
            break;
        }
    }
    return oneDTAlreadyConfigured;
}

function initializeRadioButtonGroup(componentType, unitId, topCollectionPrefix, radioGroupColumn, topCheckColumn) {
    var radioGroupName = topCollectionPrefix + unitId + prefixSeparator + radioGroupColumn;
    var radioGroup = document.getElementsByName(radioGroupName);

    var hiddenControlIdPrefix = topCollectionPrefix + unitId + prefixSeparator + topCheckColumn + suffixSeparator;

    var actionColumnPrefix = (componentType == 'sca') ? 'cb_' : '';
    var actionControlIdPrefix = actionColumnPrefix + topCollectionPrefix + unitId + prefixSeparator + componentType + suffixSeparator;

    var oneDTAlreadyConfigured = false;
    // Check for DT already configured in the given unit
    for (var row=0; row < radioGroup.length; row++ ) {    
        var rowId = row + 1;
        
        var hiddenControlId = hiddenControlIdPrefix + rowId;
        var hiddenControl = getHiddenControl(hiddenControlId);
        var deploymentTarget = hiddenControl.title;
        
        // Set the radio button control to disabled and selected if it has already been configured.
        var controlConfigured = isComponentConfigured(unitId, componentType, deploymentTarget);
        if (controlConfigured)
        {
            oneDTAlreadyConfigured = true;
            //alert("oneDTAlreadyConfigured is true for " + actionControlIdPrefix + " rowId " + rowId);
            break;
        }
    }    
    
    // Get all rows in the given unit
    for (var row=0; row < radioGroup.length; row++ ) {    
        var rowId = row + 1;
        
        var hiddenControlId = hiddenControlIdPrefix + rowId;
        var hiddenControl = getHiddenControl(hiddenControlId);
        var deploymentTarget = hiddenControl.title;
        
        // Set the radio button control to disabled and selected if it has already been configured.
        var controlConfigured = isComponentConfigured(unitId, componentType, deploymentTarget);
        
        if (controlConfigured) {
            selectConfigControl(actionControlIdPrefix, rowId);
            DisableElement(actionControlIdPrefix, rowId);
            oneDTAlreadyConfigured = true;
            
        } else {
            if (oneDTAlreadyConfigured)
            {
                DisableElement(actionControlIdPrefix, rowId);
            }
            else
            EnableElement(actionControlIdPrefix, rowId);
        }
    }
    return oneDTAlreadyConfigured;
}

function enableDisableRelatedRadioButtons(unitOptionsLength, topCollectionPrefix, radioGroupColumn, checkColumn, checkColumnPrefix, actionColumn, actionColumnPrefix, isCheckColumnValue, componentConfigInfo)
{
    var numOfUnits = unitOptionsLength - 1;
    for(var i=0; i<numOfUnits; i++)
    {
		var radioGroup = topCollectionPrefix + i + prefixSeparator + radioGroupColumn;
		var radioGroupCtrl = document.getElementsByName(radioGroup);

		// hiddenControlIdPrefix is like 'com.ibm.ws.console.wbi.ndtopology.config.DeployTargetComponentDetailForm_Collection_0_sca-'
		var hiddenControlIdPrefix = topCollectionPrefix + i + prefixSeparator + checkColumn + suffixSeparator;
		// actionControlIdPrefix is like 'cb_com.ibm.ws.console.wbi.ndtopology.config.DeployTargetComponentDetailForm_Collection_0_sca-'
		var actionControlIdPrefix = actionColumnPrefix + topCollectionPrefix + i + prefixSeparator + actionColumn + suffixSeparator;

		for (var j=0; j < radioGroupCtrl.length; j++)
		{
			// get the hidden variable value
			var hiddenControlId = hiddenControlIdPrefix + (j+1);

			var hiddenControlCount = document.getElementsByName(hiddenControlId).length;
			for (var k=0; k <hiddenControlCount ;k++)
			{
				var hiddenControl = document.getElementsByName(hiddenControlId)[k];
				if (hiddenControl.type == "hidden")
				{
					var enableCurrentItem = false;
                    var deploymentTarget = hiddenControl.title;

					if (isCheckColumnValue == true)
					{
						// The ID of the check column control is the hidden column control name with the checkColumnPrefix.
						// For example for sca (which is a checkbox), it is cb_xxx.
						var checkColumnControlId = checkColumnPrefix + hiddenControlId;
						enableCurrentItem = isControlChecked(hiddenControl.value, checkColumnControlId);
					}
					else
					{
						// Get the deployment target
						var title = deploymentTarget;
						enableCurrentItem = (isMessagingDTEnabled(title));
					}

                    // Getting the current configuration. If configured, the ctonrol is disabled and selected
                    var currentControlConfigured = isComponentConfigured(i, actionColumn, deploymentTarget);
                    if (componentConfigInfo !== undefined)
                    {
                        currentControlConfigured = componentConfigInfo[i]; 
                        //alert("componentConfigInfo is defined " + currentControlConfigured);
                    }

                    // Do not change the selection if the component has already been configured
                    if (!currentControlConfigured) {
    					if (enableCurrentItem )
    					{
    						EnableElement(actionControlIdPrefix, (j+1));
    					}
    					else
    					{
    						DisableAndResetElement(actionControlIdPrefix, (j+1));
    						var hiddenActionControlId = topCollectionPrefix + i + prefixSeparator + actionColumn + suffixSeparator + (j+1);
    						resetHiddenControlValue(hiddenActionControlId);
    					}
                    }
				}
			}//for (var k=0
		}//for (var j=0; 
    }//for(var i=0
}

// This routine is modified from setHiddenValue(). Just clear the radio button selection for the specified suffix.
function resetAndDisableVerticalRadioGroupHiddenValue(prefixColumnName, suffix, radioGroupName, radioGroupMapArray)
{
    var hiddenFieldName = "";
    var radioGroupNameStr = prefixColumnName;
    var oneRadioGroup = false;
    var suffixSeparator = "-";
    var matchFieldName = prefixColumnName +  suffixSeparator + suffix;
    var radioGroupMap = null;
      
    var hiddenFieldCount = document.getElementsByName(radioGroupNameStr).length;
    if ((radioGroupName != null) && (radioGroupName.length > 0) )
    {
        radioGroupNameStr  = radioGroupName;
        oneRadioGroup = true;
        radioGroupMap = radioGroupMapArray;
        hiddenFieldCount = radioGroupMap.length;
        for (var i=1; i <=hiddenFieldCount; i++)
        {
            if ((oneRadioGroup) && (radioGroupMap != undefined))
            {
                // Use the radioGroupMapping array to get the real hidden field name value.
                if (radioGroupMap.length >= i)
                {
                    hiddenFieldName = radioGroupMap[i-1];
                }
                else
                {
                    // Error: should not get to this branch.
                    hiddenFieldName = prefixColumnName + suffixSeparator + i;
                }
            }
            else
            {
                hiddenFieldName = prefixColumnName + suffixSeparator + i;
            }
    
            if (document.getElementsByName(hiddenFieldName) != null)
            {
                var hiddenFieldVarCount = document.getElementsByName(hiddenFieldName).length;
    
                for (var j=0; j <hiddenFieldVarCount; j++)
                {
                
                    if (document.getElementsByName(hiddenFieldName)[j].type == "hidden")
                    {
                        if (matchFieldName == hiddenFieldName)
                        {
                            if (document.getElementsByName(hiddenFieldName)[j].value == "true")
                            {                       
                                document.getElementsByName(hiddenFieldName)[j].value = false;
                                // Get the radio button group object.
                                radioObj = document.getElementsByName(radioGroupNameStr);
                                
                                if (radioObj != null)
                                {
                                    var radioLength = radioObj.length;
                                    if(radioLength == undefined) {
                                        radioObj.checked = false;
                                    }
                                    else
                                    {
                                        // uncheck all radio buttons.
    
                                        for (var k=0; k <radioObj.length; k++)
                                        {
                                            radioObj[k].checked = false;
                                        }
                                    }
                                }
                            }
                            // Disable that radio button
                            document.getElementById(hiddenFieldName).disabled = true;
                        }
                    }
                }
            }                       
        }
    }
}


// This routine is modified from enableDisableRelatedRadioButtons(). Only clear and reset the corresponding radio button if sca is uncheck.
function enableDisableBRRadioButtons(unitOptionsLength, topCollectionPrefix, radioGroupColumn, checkColumn, checkColumnPrefix, actionColumn, actionColumnPrefix, isCheckColumnValue )
{
    var numOfUnits = unitOptionsLength - 1;
    for(var i=0; i<numOfUnits; i++)
    {
        var radioGroup = topCollectionPrefix + i + prefixSeparator + radioGroupColumn;
        var radioGroupCtrl = document.getElementsByName(radioGroup);

        // hiddenControlIdPrefix is like 'com.ibm.ws.console.wbi.ndtopology.config.DeployTargetComponentDetailForm_Collection_0_sca-'
        var hiddenControlIdPrefix = topCollectionPrefix + i + prefixSeparator + checkColumn + suffixSeparator;
        // actionControlIdPrefix is like 'cb_com.ibm.ws.console.wbi.ndtopology.config.DeployTargetComponentDetailForm_Collection_0_sca-'
        var actionControlIdPrefix = actionColumnPrefix + topCollectionPrefix + i + prefixSeparator + actionColumn + suffixSeparator;
        for (var j=0; j < radioGroupCtrl.length; j++)
        {
            // get the hidden variable value
            var hiddenControlId = hiddenControlIdPrefix + (j+1);

            var hiddenControlCount = document.getElementsByName(hiddenControlId).length;
            for (var k=0; k <hiddenControlCount ;k++)
            {
                var hiddenControl = document.getElementsByName(hiddenControlId)[k];
                if (hiddenControl.type == "hidden")
                {
                    var enableCurrentItem = false;

                    if (isCheckColumnValue == true)
                    {
                        // The ID of the check column control is the hidden column control name with the checkColumnPrefix.
                        // For example for sca (which is a checkbox), it is cb_xxx.
                        var checkColumnControlId = checkColumnPrefix + hiddenControlId;
                        enableCurrentItem = isControlChecked(hiddenControl.value, checkColumnControlId);
                        //alert("enableCurrentItem is check! " +enableCurrentItem + " checkColumnControlId " + checkColumnControlId);
                    }
                    else
                    {
                        // Get the deployment target
                        var title = hiddenControl.title;
                        enableCurrentItem = (isMessagingDTEnabled(title));
                        //alert("enableCurrentItem is isMessagingDTEnabled! " +enableCurrentItem);
                    }
                    
                    if (!enableCurrentItem )
                    {
                        var prefixColumnName = topCollectionPrefix + i + prefixSeparator +actionColumn;
                        var radioGroupName = topCollectionPrefix + actionColumn;
                        resetAndDisableVerticalRadioGroupHiddenValue(prefixColumnName, parseInt(j+1), radioGroupName, brManagerRadioGroupMap);
                    }
                }
            }//for (var k=0
        }//for (var j=0; 
    }//for(var i=0
}

function setLayoutCompleted()
{
    layoutCompleted = true;
}

function doEnableDisableRadioButtons()
{
    // Only perform the enable/disable of radio buttons when the layout was completely loaded.
    if (layoutCompleted == true)
    {
            performEnableDisableRadioButtons();
    }
}

function performEnableDisableRadioButtons()
{
    // Check and disable controls if the component type for a given deployment target in a unit has already been configured
    // Messaging Aspect
    var unitCount = TabUnitOptions[messagingTabIndex].length - 1;
    for (var unit = 0; unit < unitCount; unit++) {
        initializeRadioButtonGroup("local", unit, topCollectionPrefixes[messagingTabIndex], topRadioGroupColumns[messagingTabIndex], topCheckColumns[messagingTabIndex]);
    }
    // CEI Aspect
    unitCount = TabUnitOptions[CEITabIndex].length - 1;
    for (var unit = 0; unit < unitCount; unit++) {
        initializeRadioButtonGroup("server", unit, topCollectionPrefixes[CEITabIndex], topRadioGroupColumns[CEITabIndex], topCheckColumns[CEITabIndex]);
    }
    // Application Support Aspect
    unitCount = TabUnitOptions[AppSupportTabIndex].length - 1;
    var bpcContainerConfigInfo = new Array(unitCount);
    var brManagerConfigInfo = new Array(unitCount);
    var bpcExplorerConfigInfo = new Array(unitCount);
    for (var unit = 0; unit < unitCount; unit++) {
        initializeRadioButtonGroup("sca", unit, topCollectionPrefixes[AppSupportTabIndex], topRadioGroupColumns[AppSupportTabIndex], topCheckColumns[AppSupportTabIndex]);
        bpcContainerConfigInfo[unit] = initializeRadioButtonGroup("bpcContainer", unit, topCollectionPrefixes[AppSupportTabIndex], topRadioGroupColumns[AppSupportTabIndex], topCheckColumns[AppSupportTabIndex]);
        bpcExplorerConfigInfo[unit] = initializeRadioButtonGroup("bpcExplorer", unit, topCollectionPrefixes[AppSupportTabIndex], topRadioGroupColumns[AppSupportTabIndex], topCheckColumns[AppSupportTabIndex]);
        initializeRadioButtonGroup("bpcEventCollector", unit, topCollectionPrefixes[AppSupportTabIndex], topRadioGroupColumns[AppSupportTabIndex], topCheckColumns[AppSupportTabIndex]);
        brManagerConfigInfo[unit] = initializeRadioButtonGroup("brManager", unit, topCollectionPrefixes[AppSupportTabIndex], topRadioGroupColumns[AppSupportTabIndex], topCheckColumns[AppSupportTabIndex]);
    }

    // Disable brmanager if any one of the unit is configured
    var disableBRManager = false;
    for (var unit = 0; unit < unitCount; unit++) {
        if (brManagerConfigInfo[unit])
        {
            disableBRManager = true;
            break;
        }
    }
    
	// Enable/disable the CEI and SCA according to the messaging tab value.
    for (var i=1; i < topCollectionPrefixes.length; i++)
    {
		enableDisableRelatedRadioButtons(TabUnitOptions[i].length, topCollectionPrefixes[i], topRadioGroupColumns[i], topCheckColumns[i], "", topCheckColumns[i], topActionControlPrefix[i], false);
    }

    // Handle application support specific rules
    var tabUnit = AppSupportTabIndex;
    var unitOptions = TabUnitOptions[tabUnit];
    if (disableBRManager == true)
    {
        var radioButtonId = null;
        var radioButtonObj = null;
        for (var count=0; count < brManagerRadioGroupMap.length; count++)
        {
            radioButtonId = brManagerRadioGroupMap[count];
            radioButtonObj = document.getElementById(radioButtonId);
            if ( (radioButtonObj !==null) && (radioButtonObj !== undefined))
            {
                radioButtonObj.disabled =  true;
            }
        }
    }
    else
    {
        enableDisableBRRadioButtons(unitOptions.length, topCollectionPrefixes[tabUnit], topRadioGroupColumns[tabUnit], topCheckColumns[tabUnit], topActionControlPrefix[tabUnit], "brManager", "", true);
    }

    // Disable bpc container according to SCA
    enableDisableRelatedRadioButtons(unitOptions.length, topCollectionPrefixes[tabUnit], topRadioGroupColumns[tabUnit], topCheckColumns[tabUnit], topActionControlPrefix[tabUnit], bpcContainer, "", true, bpcContainerConfigInfo);

    // Number of units is one last than the drop down list because of the first default value.
    var numOfUnits = unitOptions.length - 1;
	// Enable/disable bpc explorer based on bpc container selection.
    for(var unit=0; unit < numOfUnits; unit++)
    {
    	// Check if bpc container is selected for the unit.
		var isBPCCSelected = isBPCContainerSelected(unit);
		
        var isBPCConfigured = isComponentConfiguredInUnit('bpcContainer', unit, tabUnit);
		// Enable disable the bpcExplorer radio button group depending on if a bpc container is selected and enabled.
        var enableBpcExplorer = isBPCCSelected;
        if (isBPCConfigured && bpcExplorerConfigInfo[unit])
            enableBpcExplorer = false;
		enableDisableRadioButtonGroup(topCollectionPrefixes[tabUnit], unit, bpcExplorer, enableBpcExplorer);

		// Enable/disable bpc event collector: if isBPCContainerSelected and CEI for this dt are selected ==> BPC Event Collector enabled.
	   	// Walk thru each dt for the bpc event collector
		var radioGroup = topCollectionPrefixes[tabUnit] + unit + prefixSeparator + topRadioGroupColumns[tabUnit];
		var radioGroupCtrl = document.getElementsByName(radioGroup);
		// check sca value for the same dt
		var checkControlPrefix = topCollectionPrefixes[tabUnit] + unit + prefixSeparator + topCheckColumns[tabUnit] + suffixSeparator;
		// ActionControlPrefix is prefix for bpc event collector
		var actionControlPrefix = topCollectionPrefixes[tabUnit] + unit + prefixSeparator + bpcEventCollector + suffixSeparator;
		for (var j=0; j < radioGroupCtrl.length; j++)
		{
			// hiddenControlId is the SCA Id
			var hiddenControlId = checkControlPrefix + (j+1);

			var hiddenControlCount = document.getElementsByName(hiddenControlId).length;
			for (var k=0; k <hiddenControlCount; k++)
			{
				var control = document.getElementsByName(hiddenControlId)[k];
				if (control.type == "hidden")
				{
					// Initialized isDTChecked to false. 
					// If BPC container is selected and sca is checked, then isDTChecked may be set to true.
					var isDTChecked = false;
				
					// If bpc is select, check further to see if the bpc event collector should be enabled.
					if (isBPCCSelected)
					{
						// Get the deployment target
						var title = control.title;
						// check if CEI for the deployment target is check and enabled.
						isDTChecked = isDTCheckedAndEnabled(title, CEITabIndex, true);
					}
                    // Getting the current configuration. If configured, the ctonrol is disabled and selected
                    // Do not change the selection if the component has already been configured
                    if (!isComponentConfigured(unit, bpcEventCollector, title)) {
    					if (isDTChecked)
    						EnableElement(actionControlPrefix, (j+1));
    				    else
    				    {
    				    	DisableAndResetElement(actionControlPrefix, (j+1));
    						var actionControlId = actionControlPrefix + (j+1);
    						resetHiddenControlValue(actionControlId);
    				    }
                    }
				}				
			}// for (var k=0; 
		} //for (var j=0; 
	} //for(var unit
		
	// Enable/disable bpc observer based on bpc event collector selection
//    for (var i=0; i<numOfUnits; i++)
//    {
//		var isBPCECSelected = isBPCEventCollectorSelected(i);
//		enableDisableRadioButtonGroup(i, bpcObserver, isBPCECSelected);// Enable disable the bpcObserver radio button group depending on if a bpc event collector is selected and enabled.		
//    }
}

</script>
  
