<!-- 
 * @(#) 1.1 ATLAS/ws/code/atlas.webui/src/ndtopology/com.ibm.ws.console.wbi.ndtopology/NDTNewWizardTaskImportDbProperties.jsp, wbi.atlas.webui, BPMX.ATLAS 8/27/09 16:59:52 [9/1/09 11:36:42]
 * IBM Confidential OCO Source Material
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15, 5655-FLW, 5724-M23  Copyright International Business Machines Corp. 2009
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 *
-->
<%@ page import="java.util.*"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>


	<tiles:useAttribute id="formBean" name="bean" classname="java.lang.String"/>
	<tiles:useAttribute id="radioItemList" name="radioItemList" classname="java.util.List"/>
	<tiles:useAttribute id="prefix" name="prefix" ignore="true" classname="java.lang.String"/>
    <tiles:useAttribute id="suffix" name="suffix" ignore="true" classname="java.lang.String"/>
	<tiles:useAttribute name="hasCompatibleRuntime" classname="java.lang.String" ignore="true"/>
	<tiles:useAttribute name="hasImportDBFilename" classname="java.lang.String" ignore="true"/>
	<tiles:useAttribute name="hasCompatibleImportDBFilename" classname="java.lang.String" ignore="true"/>

	<bean:define id="bean" name="<%=formBean%>"/>
<%	
    String prefixStr = "";
    if (prefix != null && !prefix.trim().equals("")) {
		prefixStr = prefix + "_";
    }
  	  
    String suffixStr = "";
    if (suffix != null && !suffix.trim().equals("")) {
        suffixStr = "-" + suffix ;
	}

    java.util.ArrayList tempRadioItemList =  new java.util.ArrayList();
    for(int i=0;i<radioItemList.size(); i++)
    	tempRadioItemList.add(radioItemList.get(i));
    
    String hasCompatibleRuntimeStr = "";
    if (hasCompatibleRuntime != null)
    {
    	hasCompatibleRuntimeStr = hasCompatibleRuntime.trim();
    	if (hasCompatibleRuntimeStr.equalsIgnoreCase("false"))
    	{
    		// Remove all but the first item.
    		for (int j=(tempRadioItemList.size() - 1); j > 0; j--)
    		{
    			tempRadioItemList.remove(j);
    		}    		
    	}
    }
    session.setAttribute("tempRadioItemList",tempRadioItemList);
    
    %>
    


<script type="text/javascript">

function fileSelected(field, hiddenField) {
    var file = document.getElementById(field).value;
    document.getElementById(field + ".text").value = file;
    document.getElementById(hiddenField).value = file;
}

function removeFile(field, hiddenField) {
    document.getElementById(field + ".text").value = "";
    document.getElementById(hiddenField).value = "";
document.getElementById("div." + field + ".file").innerHTML = "<input type='file' size='60' name='" + field +"' id='" + field +"' value='' class='fileUpload' onchange=\"fileSelected('" + field + "', '" + hiddenField + "');\" onblur=\"fileSelected('"+field + "', '" + hiddenField + "');\"/>" +
"\n<input type='button' class='buttons' style='font-family:Verdana,sans-serif;background-color:#EAF1FF;FONT-SIZE:95.0%;' value='" + getClearStr() + "' onclick=\"removeFile('" + field + "', '" + hiddenField + "')\"/>";


    document.getElementById("div." + field + ".text").style.display = "none";
    document.getElementById("div." + field + ".file").style.display = "block";
}


function fileAdded(field) {
    document.getElementById("div." + field + ".text").style.display = "block";
    document.getElementById("div." + field + ".file").style.display = "none";
}

function getClearStr() {

var clearStr = "<bean:message key="NDTNewWizardTask.importdb.clear"/>";
return clearStr;
}

</script>

<table border="0" cellspacing="0" cellpadding="0">
            <% int currentCount = 0; %>

			<logic:iterate id="item" name="tempRadioItemList" type="com.ibm.ws.console.wbi.common.item.PropertyItem2">            
<%
				
				if (item.getType().equalsIgnoreCase("filepath"))
				{
					String hiddenName = item.getUnits();
					
					String importFileStyle = "block";
					String importTextStyle = "none";
					if (currentCount++ < 1) 
					{
						if (hasImportDBFilename != null && hasImportDBFilename.equalsIgnoreCase("true")) {
						    importFileStyle = "none";
						    importTextStyle = "block";
						}
					}
					else
					{
						if (hasCompatibleImportDBFilename != null && hasCompatibleImportDBFilename.trim().equalsIgnoreCase("true")) {
							importFileStyle = "none";
							importTextStyle = "block";
						}
					}
					%>					

				 <tr valign="top">					 
                    <td>
                    	<input name="<%=hiddenName%>" id="<%=hiddenName%>" value="<bean:write property='<%=hiddenName%>' name='com.ibm.ws.console.wbi.ndtopology.wizard.NDTNewWizardTaskForm'/>" type="hidden" />
                    </td>
					<td class="table-text"  scope="row" valign="top">
					
						<label for="<%=item.getAttribute()%>" TITLE="<bean:message key="<%=item.getDescription()%>"/>">
						</label>
						<bean:message key="<%=item.getLabel()%>" /><br>
						<div id="div.<%=item.getAttribute()%>.file" style="display: <%=importFileStyle %>;">
                			<input type="file" size="60" name="<%=item.getAttribute()%>" id="<%=item.getAttribute()%>" value="" class="fileUpload" onchange="fileSelected('<%=item.getAttribute()%>','<%=hiddenName%>')" onblur="fileSelected('<%=item.getAttribute()%>','<%=hiddenName%>')"/>
                			<input type="button" class="buttons" style="font-family:Verdana,sans-serif;background-color:#EAF1FF;FONT-SIZE:95.0%;" value="<bean:message key="NDTNewWizardTask.importdb.clear"/>" onclick="removeFile('<%=item.getAttribute()%>','<%=hiddenName%>')"/>
            			</div>
            			<div id="div.<%=item.getAttribute()%>.text" style="display: <%=importTextStyle %>;">
                			<input type="text" size="60" value="<bean:write property='<%=hiddenName%>' name='com.ibm.ws.console.wbi.ndtopology.wizard.NDTNewWizardTaskForm'/>" id="<%=item.getAttribute()%>.text" disabled="disabled"/>
                			<input type="button" class="buttons" style="font-family:Verdana,sans-serif;background-color:#EAF1FF;FONT-SIZE:95.0%;" value="<bean:message key="NDTNewWizardTask.importdb.clear"/>" onclick="removeFile('<%=item.getAttribute()%>','<%=hiddenName%>')"/>
            			</div>
							

                    </td>
                </tr>
                <br />
<%
				}
%>
</logic:iterate>

</table>

