<!-- 
 * @(#) 1.1 ATLAS/ws/code/atlas.webui/src/ndtopology/com.ibm.ws.console.wbi.ndtopology/clusterName.jsp, wbi.atlas.webui, BPM70.ATLAS 2/12/10 11:16:31 [2/19/10 19:12:30]
 * IBM Confidential OCO Source Material
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15, 5655-FLW, 5724-M23  Copyright International Business Machines Corp. 2010
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 *
 -->
<%@ page import="com.ibm.ws.console.wbi.ndtopology.wizard.NDTNewWizardTaskForm"%>

<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute name="bean" classname="java.lang.String" />
<tiles:useAttribute name="property" classname="java.lang.String" />

<bean:define id="formBean" name="<%=bean %>"/>

<bean:define id="wizardBean" name="com.ibm.ws.console.wbi.ndtopology.wizard.NDTNewWizardTaskForm"/>

<%NDTNewWizardTaskForm nDTNewWizardTaskForm = (NDTNewWizardTaskForm)wizardBean;
		if (nDTNewWizardTaskForm.isZOS()) {
		%>
		
        <tiles:insert page="/com.ibm.ws.console.wbi.common/textFieldLayout.jsp" flush="false">
        <tiles:put name="property" value="shortClusterName" />
        <tiles:put name="isReadOnly" value="no" />
        <tiles:put name="isRequired" value="no" />
        <tiles:put name="label" value="NDTNewWizardTask.clusters.shortName.displayName" />
        <tiles:put name="size" value="60" />
        <tiles:put name="units" value=""/>
        <tiles:put name="desc" value="NDTNewWizardTask.clusters.shortName.description"/>
        <tiles:put name="bean" value="<%=bean%>" />
        <tiles:put name="maxLength" value="8" />
        <tiles:put name="style" value="text-transform:uppercase" />
        </tiles:insert>

		<%	} %>
		
<input TYPE="hidden" name="hiddenClusterName" id="hiddenClusterName" value="<bean:write property='clusterName' name='<%=bean%>'/>"/>      
<input TYPE="hidden" name="hiddenClusterMemberCount" id="hiddenClusterMemberCount" value="<bean:write property='<%=property %>' name='<%=bean%>'/>"/>      

<script type="text/javascript">

function trimString(theString)
{
	while (theString.substring(0,1) === ' ')
	{
		theString = theString.substring(1, theString.length);
	}
	while (theString.substring(theString.length-1, theString.length) === ' ')
	{
		theString = theString.substring(0, theString.length-1);
	}
	return theString;
}

function setClusterMemberName()
{
	var clusterName = trimString(document.getElementById("hiddenClusterName").value) + ".";
	var clusterNameLength = clusterName.length;
	var newClusterName = trimString(document.getElementById("clusterName").value);
	var newClusterNameWithDot = newClusterName + ".";
	var clusterMemberCount = document.getElementById("hiddenClusterMemberCount").value;

	for (var i = 1; i <= clusterMemberCount; i++)
	{ 
        var memberReference = "com.ibm.ws.console.wbi.ndtopology.wizard.NDTClusterMemberDetailForm_Collection_0_clusterMemberName-" + i;
		var memberName = document.getElementById(memberReference);

		var memberNameValue = trimString(memberName.value);
		if (memberNameValue.substring(0, clusterNameLength) === clusterName)
		{
			document.getElementById(memberReference).value = newClusterNameWithDot + memberNameValue.substring(clusterNameLength, memberNameValue.length);
		}
	}
	// Update the hidden value
	document.getElementById("hiddenClusterName").value = newClusterName;
}

document.getElementById("clusterName").onchange=setClusterMemberName

</script>
